
struct VS_OUT
{
	float4 hPosition	: POSITION;
	float4 cPosition	: TEXCOORD1;
	float2 texCoord		: TEXCOORD0;
	float r				: TEXCOORD2;	
	float4 center		: TEXCOORD3;
};

VS_OUT HPS_Smoke_L_VS (float4 position : POSITION,	
		float4 texCoord : TEXCOORD0,
		
		uniform float4x4 worldView,
		uniform float4x4 Proj,
		uniform float4x4 worldViewProj)
{
	VS_OUT OUT;
  
	float2 offset = texCoord.zw;
	float4 cPosition;   
	cPosition = mul(worldView, position);
	OUT.center = cPosition;	
	cPosition.xy += offset;				
	OUT.cPosition = cPosition;
	OUT.r = abs(texCoord.z);		
 
    OUT.hPosition = mul( Proj, cPosition );
     
    OUT.texCoord = texCoord.xy;    
	return OUT;
} 


float4 HPS_Smoke_L_PS(VS_OUT IN,
						uniform float4x4 Proj,
						uniform sampler2D Texture	) : COLOR
{
	float4 Color = 0;
	Color = tex2D(Texture, IN.texCoord);
	Color = float4(1, 1, 1, Color.a);
	return Color; 
}
